Index: /trunk/kernel/fs/fatfs.c
===================================================================
--- /trunk/kernel/fs/fatfs.c	(revision 656)
+++ /trunk/kernel/fs/fatfs.c	(revision 657)
@@ -2,5 +2,5 @@
  * fatfs.c - FATFS file system API implementation.
  *
- * Author    Alain Greiner (2016,2017,2018,2019)
+ * Author    Alain Greiner (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -122,5 +122,5 @@
         for( i = nbytes ; i > 0 ; i-- )
         {
-            res = (res<<8) | hal_remote_lb( buffer_xp+offset+i-1 );
+            res = (res<<8) | hal_remote_lb( buffer_xp + offset + i-1 );
         }
     }
@@ -129,5 +129,5 @@
         for( i = 0 ; i < nbytes ; i++ )
         {
-            res = (res<<8) | hal_remote_lb( buffer_xp+offset+i );
+            res = (res<<8) | hal_remote_lb( buffer_xp + offset + i );
         }
     }
@@ -135,4 +135,6 @@
 
 }  // end fatfs_get_remote_record()
+
+/*
 
 //////////////////////////////////////////////////////////////////////////////////////////
@@ -164,4 +166,6 @@
 }  // end fatfs_set_record()
 
+*/
+
 //////////////////////////////////////////////////////////////////////////////////////////
 // This function writes one, two, or four bytes from a 32 bits integer to a remote
@@ -185,5 +189,5 @@
         for( i = nbytes ; i > 0 ; i-- )
         {
-            hal_remote_sb( (buffer_xp+offset+i-1) , (uint8_t)(value>>((i-1)<<3)) );
+            hal_remote_sb( (buffer_xp + offset + i-1 ) , (uint8_t)(value>>((i-1)<<3)) );
         }
     }
@@ -192,5 +196,5 @@
         for( i = 0 ; i < nbytes ; i++ )
         {
-            hal_remote_sb( (buffer_xp+offset+i) , (uint8_t)(value>>((nbytes-1-i)<<3)) );
+            hal_remote_sb( (buffer_xp + offset + i) , (uint8_t)(value>>((nbytes-1-i)<<3)) );
         }
     }
@@ -470,5 +474,4 @@
     cxy_t         fat_cxy;         // FAT cluster identifier
     fatfs_ctx_t * fatfs_ctx;       // local pointer on FATFS context in FAT cluster
-    xptr_t        fat_mapper_xp;   // extended pointer on FAT mapper
     mapper_t    * fat_mapper_ptr;  // local pointer on FAT mapper
     uint32_t      page_id;         // current page index in FAT mapper
@@ -482,10 +485,6 @@
     fatfs_ctx = GET_PTR( fatfs_ctx_xp );
  
-    // get FAT mapper pointers from FATFS context 
-    fat_mapper_xp  = hal_remote_l64( XPTR( fat_cxy , &fatfs_ctx->fat_mapper_xp ) );
-    fat_mapper_ptr = GET_PTR( fat_mapper_xp );
-
-// check FAT cluster
-assert( (fat_cxy == GET_CXY( fat_mapper_xp )) , "unconsistent FAT cluster" );
+    // get FAT mapper pointer from FATFS context 
+    fat_mapper_ptr  = hal_remote_lpt( XPTR( fat_cxy , &fatfs_ctx->fat_mapper ) );
 
     // build extended pointer on FAT mapper radix tree
@@ -575,5 +574,5 @@
     
     // update the FS_INFO sector on IOC device
-    return dev_ioc_move_data( IOC_SYNC_WRITE , fs_info_buffer_xp , fs_info_lba , 1 );
+    return dev_ioc_sync_write( fs_info_buffer_xp , fs_info_lba , 1 );
  
 }  // end fatfs_update_ioc_fsinfo()
@@ -581,33 +580,34 @@
 //////////////////////////////////////////////////////////////////////////////////////////
 // This static function decrements the  "free_clusters" variable, and updates the 
-// "free_cluster_hint" variable in the FATFS context in FAT cluster, identified 
-// by the <fat_ctx_xp> argument, when a new <cluster> has been allocated from FAT.
+// "free_cluster_hint" variable in the FATFS context in FAT cluster,  when a new 
+// <cluster_id> has been allocated from the FAT.
+// It synchronously updates the FS_INFO sector on the IOC device. 
+// The FATFS context in FAT cluster is identified by the <fat_ctx_xp> argument.
+// It can be called by a thead running in any cluster. 
 // It scan all slots in the FAT mapper seen as an array of 32 bits words, looking for the
-// first free slot larger than the <cluster> argument, to update "free_cluster_hint".
-// It synchronously updates the FS_INFO sector on the IOC device. 
-// It can be called by a thead running in any cluster. 
+// first free slot larger than the <cluster_id>.
 // The lock protecting exclusive access to the FAT must be taken by the calling function. 
 //////////////////////////////////////////////////////////////////////////////////////////
 // @ fatfs_ctx_xp  : extended pointer on FATFS context in FAT cluster. 
-// @ cluster       : recently allocated cluster index in FAT.
+// @ cluster_id    : recently allocated cluster index in FAT.
 // @ return 0 if success, return -1 if the FS_INFO sector cannot be updated.
 //////////////////////////////////////////////////////////////////////////////////////////
 static error_t fatfs_free_clusters_decrement( xptr_t    fatfs_ctx_xp,
-                                              uint32_t  cluster )
+                                              uint32_t  cluster_id )
 {
     error_t       error;
-    cxy_t         fat_cxy;        // FAT cluster identifier
-    fatfs_ctx_t * fat_ctx_ptr;    // local pointer on fatfs context in FAT cluster
-    xptr_t        fat_mapper_xp;  // extended pointer on FAT mapper
-    xptr_t        hint_xp;        // extended pointer on "free_cluster_hint" shared variable
-    xptr_t        numb_xp;        // extended pointer on "free_clusters" shared variable 
-    uint32_t      numb;           // "free_clusters" variable current value
-    uint32_t      hint;           // "free_cluster_hint" variable current value
-    uint32_t      page_id;        // page index in FAT mapper
-    uint32_t      slot_id;        // slot index in one page of FAT (1024 slots per page)
-    uint32_t      page_max;       // max number of pages in FAT mapper
-    xptr_t        page_xp;        // extended pointer on current page in FAT mapper
-    xptr_t        base_xp;        // extended pointer on current page base
-    xptr_t        slot_xp;        // extended pointer on current slot in FAT mapper
+    cxy_t         fat_cxy;         // FAT cluster identifier
+    fatfs_ctx_t * fat_ctx_ptr;     // local pointer on fatfs context in FAT cluster
+    mapper_t    * fat_mapper_ptr;  // local pointer on FAT mapper
+    xptr_t        fat_mapper_xp;   // extended pointer on FAT mapper
+    xptr_t        hint_xp;         // extended pointer on "free_cluster_hint" shared variable
+    xptr_t        numb_xp;         // extended pointer on "free_clusters" shared variable 
+    uint32_t      page_id;         // page index in FAT mapper
+    uint32_t      slot_id;         // slot index in one page of FAT (1024 slots per page)
+    uint32_t      page_max;        // max number of pages in FAT mapper
+    xptr_t        page_xp;         // extended pointer on current page in FAT mapper
+    xptr_t        base_xp;         // extended pointer on current page base
+    xptr_t        slot_xp;         // extended pointer on current slot in FAT mapper
+    uint32_t      found;           // free slot found when non zero
 
 #if DEBUG_FATFS_FREE_CLUSTERS
@@ -615,6 +615,6 @@
 thread_t * this  = CURRENT_THREAD;
 if( DEBUG_FATFS_FREE_CLUSTERS < cycle )
-printk("\n[%s] thread[%x,%x] enter for allocated cluster %x / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, cluster , cycle );
+printk("\n[%s] thread[%x,%x] enter for allocated cluster_id %x / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, cluster_id , cycle );
 #endif
 
@@ -627,22 +627,19 @@
     numb_xp = XPTR( fat_cxy , &fat_ctx_ptr->free_clusters );
 
-    // update "free_clusters" value
-    numb = hal_remote_l32( numb_xp ) - 1;
-    hal_remote_s32( numb_xp , numb );
-
-    // get extended pointer on FAT mapper
-    fat_mapper_xp = hal_remote_l64( XPTR( fat_cxy , &fat_ctx_ptr->fat_mapper_xp ) );
-
-    // initialise variables to scan the FAT mapper
-    // and find the first free slot > cluster
-    page_id  = (cluster + 1) >> 10;
-    slot_id  = (cluster + 1) & 0x3FF;
+    // get pointers on FAT mapper from FATFS context
+    fat_mapper_ptr = hal_remote_lpt( XPTR( fat_cxy , &fat_ctx_ptr->fat_mapper ) );
+    fat_mapper_xp  = XPTR( fat_cxy , fat_mapper_ptr );
+
+    // initialise the loop variables to scan the FAT mapper
+    page_id  = (cluster_id + 1) >> 10;
+    slot_id  = (cluster_id + 1) & 0x3FF;
     page_max = hal_remote_l32( XPTR( fat_cxy, &fat_ctx_ptr->fat_sectors_count ) ) >> 3;
-
-    // scan FAT mapper / loop on pages
-    while ( page_id < page_max )            
+    found    = 0;
+
+    // scan FAT mapper : first loop on pages
+    while ( (page_id < page_max) && (found == 0) )            
     {
         // get current page from mapper
-        page_xp = mapper_remote_get_page( fat_mapper_xp , page_id );
+        page_xp = mapper_get_fat_page( fat_mapper_xp , page_id );
 
         if( page_xp == XPTR_NULL )
@@ -655,6 +652,6 @@
         base_xp = ppm_page2base( page_xp );
 
-        // scan FAT mapper / loop on slots
-        while ( slot_id < 1024 )
+        // scan the FAT mapper : second loop on slots
+        while ( (slot_id < 1024) && (found == 0) )
         {
             // get extended pointer on current slot
@@ -664,43 +661,50 @@
             if ( hal_remote_l32( slot_xp ) == FREE_CLUSTER )
             {
-                // update "free_cluster_hint" value
-                hint = (page_id << 10) + slot_id - 1;
-                hal_remote_s32( hint_xp , hint );
-
-                // update FS_INFO sector on IOC device
-                error = fatfs_update_ioc_fat( fatfs_ctx_xp,
-                                              page_id,
-                                              page_id );
-
-                if( error ) 
-                {
-                    printk("\n[ERROR] in %s : cannot update FS_INFO on IOC\n", __FUNCTION__ );
-                    return -1;
-                }
+                // exit both loops
+                found = 1;
+            }
+            else
+            {
+                // update slot_id if not found
+                slot_id++;
+            }
+        }  // end loop on slots
+
+        // update page_id & slot_id variables if not found
+        if( found == 0 )
+        {
+            page_id++;
+            slot_id = 0;
+        }
+    }  // end loop on pages
+
+    if( found )  // free cluster found
+    {
+        // update "free_clusters" and "free_cluster_hint" value in FATFS context
+        hal_remote_atomic_add( numb_xp , -1 );
+        hal_remote_s32( hint_xp , (page_id << 10) + slot_id - 1 );
+
+        // update FS_INFO sector on IOC device
+        error = fatfs_update_ioc_fsinfo( fatfs_ctx_xp );
+
+        if( error ) 
+        {
+            printk("\n[ERROR] in %s : cannot update FS_INFO on IOC\n", __FUNCTION__ );
+            return -1;
+        }
 
 #if DEBUG_FATFS_FREE_CLUSTERS 
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_FATFS_FREE_CLUSTERS < (uint32_t)hal_get_cycles() )
-printk("\n[%s] thread[%x,%x] exit / hint %x / free %x / cycle %d\n",
+if( DEBUG_FATFS_FREE_CLUSTERS < cycle )
+printk("\n[%s] thread[%x,%x] exit / hint %x / free %x\n",
 __FUNCTION__, this->process->pid, this->trdid, 
-hal_remote_l32(hint_xp), hal_remote_l32(numb_xp), cycle );
-#endif
-                return 0;
-            }
-
-            // update slot_id
-            slot_id = 0;
-
-        }  // end loop on slots
-
-        // update page_id & slot_id variables
-        page_id++;
-        slot_id = 0;
-
-    }  // end loop on pages
-
-    // return error if no free cluster found 
-    printk("\n[ERROR] in %s : No free cluster found\n", __FUNCTION__ );
-    return -1;
+hal_remote_l32(hint_xp), hal_remote_l32(numb_xp) );
+#endif
+        return 0;
+    }
+    else  // free cluster not found
+    {
+        printk("\n[ERROR] in %s : No free cluster_id found\n", __FUNCTION__ );
+        return -1;
+    }
     
 }  // end fatfs_free_clusters_decrement()
@@ -709,19 +713,19 @@
 // This static function increments the "free_clusters" variable, and updates the
 // "free_cluster_hint" variables in the FATFS context in FAT cluster, identified 
-// by the <fat_ctx_xp> argument, when a FATFS cluster is released.
+// by the <fat_ctx_xp> argument, when a FATFS <cluster_id> has been released.
 // If the released cluster index is smaller than the current (hint) value, 
 // it set "free_cluster_hint" <= cluster.
-// It does NOT update the  FS_INFO sector on the IOC device.
+// It does NOT update the  FS_INFO sector on the IOC device, as this is done by the
+// calling fatfs_release_inode() function.
 // It can be called by a thead running in any cluster. 
 // The lock protecting exclusive access to the FAT must be taken by the calling function. 
 //////////////////////////////////////////////////////////////////////////////////////////
 // @ fatfs_ctx_xp  : extended pointer on FATFS context in FAT cluster. 
-// @ cluster       : recently released cluster index in FAT.
+// @ cluster_id    : recently released cluster index in FAT.
 // @ return 0 if success, return -1 if the FS_INFO sector cannot be updated.
 //////////////////////////////////////////////////////////////////////////////////////////
 static error_t fatfs_free_clusters_increment( xptr_t   fatfs_ctx_xp,
-                                              uint32_t cluster )
-{
-    error_t       error;
+                                              uint32_t cluster_id )
+{
     cxy_t         fat_cxy;      // FAT cluster identifier
     fatfs_ctx_t * fat_ctx_ptr;  // local pointer on fatfs context in FAT cluster
@@ -735,6 +739,6 @@
 thread_t * this  = CURRENT_THREAD;
 if( DEBUG_FATFS_FREE_CLUSTERS < cycle )
-printk("\n[%s] thread[%x,%x] enter for released cluster %x / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, cluster , cycle );
+printk("\n[%s] thread[%x,%x] enter for released cluster_id %x / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, cluster_id , cycle );
 #endif
 
@@ -753,5 +757,5 @@
     // update "numb" and "hint" variables as required
     numb++;
-    if ( (cluster - 1) < hint ) hint = cluster - 1;
+    if ( (cluster_id - 1) < hint ) hint = cluster_id - 1;
 
     // update free_clusters
@@ -759,19 +763,9 @@
     hal_remote_s32( hint_xp , hint );
 
-    // update FS_INFO sector on IOC device
-    error = fatfs_update_ioc_fsinfo( fatfs_ctx_xp );
-
-    if( error ) 
-    {
-        printk("\n[ERROR] in %s : cannot update FS_INFO on IOC\n", __FUNCTION__ );
-        return -1;
-    }
-
 #if DEBUG_FATFS_FREE_CLUSTERS 
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_FATFS_FREE_CLUSTERS < (uint32_t)hal_get_cycles() )
-printk("\n[%s] thread[%x,%x] exit / hint %x / free %x / cycle %d\n",
+if( DEBUG_FATFS_FREE_CLUSTERS < cycle )
+printk("\n[%s] thread[%x,%x] exit / hint %x / free %x\n",
 __FUNCTION__, this->process->pid, this->trdid,
-hal_remote_l32( hint_xp ), hal_remote_l32( numb_xp ), cycle );
+hal_remote_l32( hint_xp ), hal_remote_l32( numb_xp ) );
 #endif
 
@@ -853,7 +847,222 @@
 
 //////////////////////////////////////////////////////////////////////////////////////////
+// This static function access the FAT mapper to allocate a new cluster in the FATFS,
+// and returns in <searched_cluster_id> the FATFS cluster index of a free cluster.
+// It updates the FAT mapper (handling miss from IOC device if required) :
+// - if the <last_cluster_id> is zero, the new cluster is the first allocated cluster,
+//   and the <searched_cluster_id> FAT slot is set to END_OF_CHAIN_CLUSTER.
+// - if the <last_cluster_id> argument is not zero, the new cluster is not the first,
+//   the <last_cluster_id> FAT slot is set to <searched_cluster_id>, 
+//   the <searched_cluster_id> FAT slot is set to END_OF_CHAIN_CLUSTER.
+// This function also updates the  two "free_cluster_hint" and "free_clusters" variables
+// stored in the FATFS context. It takes the rwlock stored in the FATFS context in the
+// FAT cluster to get exclusive access to the FAT.
+// This function synchronously updates the FAT region on IOC device. 
+// It can be called by a thread running in any cluster as it uses remote accesses.
+//////////////////////////////////////////////////////////////////////////////////////////
+// @ last_cluster_id      : [in]  previous last cluster index. 
+// @ searched_cluster_id  : [out] allocated cluster index.
+// @ return 0 if success / return -1 if no more free clusters on IOC device.
+//////////////////////////////////////////////////////////////////////////////////////////
+static error_t fatfs_cluster_alloc( uint32_t   last_cluster_id,
+                                    uint32_t * searched_cluster_id )
+{
+    error_t       error;
+    uint32_t      free_clusters;   // total number of free clusters
+    uint32_t      hint;            // hint + 1 is the first free cluster
+    uint32_t      new_cluster_id;  // allocated cluster index in FAT
+    uint32_t      new_page_id;     // allocated cluster page index in FAT mapper
+    uint32_t      new_slot_id;     // allocated cluster slot index in page (1024 slots per page)
+    xptr_t        new_page_xp;     // extended pointer on FAT page for allocated cluster
+    xptr_t        new_slot_xp;     // extended pointer on allocated cluster slot in FAT 
+    uint32_t      last_page_id;    // last cluster page index in FAT mapper
+    uint32_t      last_slot_id;    // last cluster slot index in page (1024 slots per page)
+    xptr_t        last_slot_xp;    // extended pointer on last cluster slot in FAT 
+    xptr_t        last_page_xp;    // extended pointer on FAT page for last cluster
+    vfs_ctx_t   * vfs_ctx;         // local pointer on VFS context (same in all clusters)
+    fatfs_ctx_t * loc_fatfs_ctx;   // local pointer on local FATFS context
+    fatfs_ctx_t * fat_fatfs_ctx;   // local pointer on FATFS context in FAT cluster
+    mapper_t    * fat_mapper_ptr;  // local pointer on FAT mapper
+    xptr_t        fat_mapper_xp;   // extended pointer on FAT mapper
+    cxy_t         fat_cxy;         // FAT mapper cluster identifier
+    xptr_t        lock_xp;         // extended pointer on lock protecting free clusters info
+    xptr_t        hint_xp;         // extended pointer on free_cluster_hint in FAT cluster
+    xptr_t        free_xp;         // extended pointer on free_clusters_number in FAT cluster
+    
+#if DEBUG_FATFS_CLUSTER_ALLOC
+uint32_t   cycle = (uint32_t)hal_get_cycles();
+thread_t * this  = CURRENT_THREAD;
+if( DEBUG_FATFS_CLUSTER_ALLOC < cycle )
+printk("\n[%s] thread[%x,%x] enter / lats_cluster_id %x / cycle = %d\n",
+__FUNCTION__, this->process->pid, this->trdid, last_cluster_id, cycle );
+#endif
+
+    // get local pointer on VFS context (same in all clusters)
+    vfs_ctx = &fs_context[FS_TYPE_FATFS];
+
+    // get local pointer on local FATFS context
+    loc_fatfs_ctx = vfs_ctx->extend;
+
+    // get FAT cluster
+    fat_cxy = CONFIG_VFS_ROOT_CXY;
+
+    // get pointers on FAT mapper
+    fat_mapper_ptr = loc_fatfs_ctx->fat_mapper;
+    fat_mapper_xp  = XPTR( fat_cxy , fat_mapper_ptr );
+
+    // get local pointer on FATFS context in FAT cluster 
+    fat_fatfs_ctx = hal_remote_lpt( XPTR( fat_cxy , &vfs_ctx->extend ) );
+
+    // build relevant extended pointers on free clusters info in FAT cluster 
+    lock_xp = XPTR( fat_cxy , &fat_fatfs_ctx->lock );
+    hint_xp = XPTR( fat_cxy , &fat_fatfs_ctx->free_cluster_hint );
+    free_xp = XPTR( fat_cxy , &fat_fatfs_ctx->free_clusters );
+
+    // take the FAT lock in write mode
+    remote_rwlock_wr_acquire( lock_xp );
+
+    // get hint and free_clusters values from FATFS context in FAT cluster
+    hint          = hal_remote_l32( hint_xp );
+    free_clusters = hal_remote_l32( free_xp );
+        
+#if (DEBUG_FATFS_CLUSTER_ALLOC & 1)
+if( DEBUG_FATFS_CLUSTER_ALLOC < cycle )
+printk("\n[%s] thread[%x,%x] get free info : hint %x / free_clusters %x\n",
+__FUNCTION__, this->process->pid, this->trdid, hint, free_clusters );
+#endif
+
+    // check "free_clusters"
+    if ( free_clusters == 0 )
+    {
+        printk("\n[ERROR] in %s : no more free FATFS clusters\n", __FUNCTION__ );
+        remote_rwlock_wr_release( lock_xp );
+        return -1;
+    }
+    else if ( free_clusters < CONFIG_VFS_FREE_CLUSTERS_MIN )
+    {
+        printk("\n[WARNING] in %s : only %d free FATFS clusters\n", 
+        __FUNCTION__, CONFIG_VFS_FREE_CLUSTERS_MIN );
+    }
+
+    // get new cluster, page & slot indexes in FAT
+    new_cluster_id = hint + 1; 
+    new_page_id    = new_cluster_id >> 10;
+    new_slot_id    = new_cluster_id & 0x3FF;
+
+    // get relevant FAT page descriptor from FAT mapper
+    new_page_xp = mapper_get_fat_page( fat_mapper_xp , new_page_id );
+
+    if( new_page_xp == XPTR_NULL )
+    {
+        printk("\n[ERROR] in %s : cannot acces FAT mapper\n", __FUNCTION__ );
+        remote_rwlock_wr_release( lock_xp );
+        return -1;
+    }
+
+    // build extended pointer on new cluster slot in FAT mapper
+    new_slot_xp = ppm_page2base( new_page_xp ) + (new_slot_id << 2);
+         
+    // check selected cluster actually free
+    if( hal_remote_l32( new_slot_xp ) != FREE_CLUSTER )
+    { 
+        printk("\n[ERROR] in %s : selected cluster_id %x not free\n",
+        __FUNCTION__, new_cluster_id );
+        remote_rwlock_wr_release( lock_xp );
+        return -1;
+    }
+
+    // update new_cluster slot in FAT mapper
+    hal_remote_s32( new_slot_xp  , END_OF_CHAIN_CLUSTER_MIN );
+
+    // handle last_cluster_id argument if non zero
+    if( last_cluster_id )
+    {
+        // get last cluster page & slot indexes in FAT
+        last_page_id    = last_cluster_id >> 10;
+        last_slot_id    = last_cluster_id & 0x3FF;
+
+        // get relevant FAT page descriptor from FAT mapper
+        last_page_xp = mapper_get_fat_page( fat_mapper_xp , last_page_id );
+
+        if( last_page_xp == XPTR_NULL )
+        {
+            printk("\n[ERROR] in %s : cannot acces FAT mapper\n", __FUNCTION__ );
+            remote_rwlock_wr_release( lock_xp );
+            return -1;
+        }
+
+        // build extended pointer on new cluster slot in FAT mapper
+        last_slot_xp = ppm_page2base( last_page_xp ) + (last_slot_id << 2);
+         
+        // check last cluster actually end of chain
+        if( hal_remote_l32( last_slot_xp ) != END_OF_CHAIN_CLUSTER_MIN )
+        { 
+            printk("\n[ERROR] in %s : last_cluster_id %x not END_OF_CHAIN\n",
+            __FUNCTION__, last_cluster_id );
+            remote_rwlock_wr_release( lock_xp );
+            return -1;
+        }
+
+        // update last_cluster slot in FAT mapper
+        hal_remote_s32( last_slot_xp , new_cluster_id );
+    }
+    else
+    {
+        last_page_xp = XPTR_NULL;
+    }
+
+    // update the FAT new_page on device
+    error = fatfs_move_page( new_page_xp , IOC_SYNC_WRITE );
+
+    if( error )
+    { 
+        printk("\n[ERROR] in %s : cannot update FAT on IOC device\n", __FUNCTION__ );
+        remote_rwlock_wr_release( lock_xp );
+        return -1;
+    }
+
+    // update the FAT last_page on device when required
+    if( (last_page_xp != XPTR_NULL) && (last_page_xp != new_page_xp) )
+    {
+        error = fatfs_move_page( last_page_xp , IOC_SYNC_WRITE );
+
+        if( error )
+        { 
+            printk("\n[ERROR] in %s : cannot update FAT on IOC device\n", __FUNCTION__ );
+            remote_rwlock_wr_release( lock_xp );
+            return -1;
+        }
+    }
+
+    // update free cluster info in FATFS context and in FS_INFO sector
+    error = fatfs_free_clusters_decrement( XPTR( fat_cxy , fat_fatfs_ctx ) , new_cluster_id );
+
+    if( error )
+    { 
+        printk("\n[ERROR] in %s : cannot update free cluster info\n", __FUNCTION__ );
+        remote_rwlock_wr_release( lock_xp );
+        return -1;
+    }
+
+    // release FAT lock
+    remote_rwlock_wr_release( lock_xp );
+
+#if DEBUG_FATFS_CLUSTER_ALLOC 
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_FATFS_CLUSTER_ALLOC < cycle )
+printk("\n[%s] thread[%x,%x] exit / allocated cluster_id %x in FAT / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, new_cluster_id, cycle );
+#endif
+
+    *searched_cluster_id = new_cluster_id;
+    return 0;
+
+}  // end fatfs_cluster_alloc()
+
+
+//////////////////////////////////////////////////////////////////////////////////////////
 // This static function access the FAT (File Allocation Table), stored in the FAT mapper,
 // and returns in <searched_cluster_id> the FATFS cluster_id for a given page of a given 
-// inode, identified by the <searched_page_id> argument, that is the page index in file
+// inode, identified by the <searched_page_id> argument that is the page index in file
 // (i.e. the page index in file mapper). The entry point in the FAT is defined by the
 // <first_cluster_id> argument, that is the cluster_id of an already allocated cluster.
@@ -861,6 +1070,5 @@
 // fatfs_inode extension), or any page of the file whose <first_page_id> argument
 // is smaller than the searched <first_page_id> argument. 
-// This function can be called by a thread running in any cluster, as it uses remote
-// access primitives when the FAT mapper is remote.
+// This function can be called by a thread running in any cluster.
 // The FAT mapper being a WRITE-THROUGH cache, this function updates the FAT mapper 
 // from informations stored on IOC device in case of miss when scanning the FAT mapper.
@@ -885,4 +1093,8 @@
     uint32_t   current_cluster_id;     // index of cluster in FATFS
     xptr_t     lock_xp;                // extended pointer on FAT lock
+    xptr_t     fat_mapper_xp;          // extended pointer on FAT mapper
+    mapper_t * fat_mapper_ptr;         // local pointer on FAT mapper
+    cxy_t      fat_cxy;                // FAT cluster
+    error_t    error;
 
 assert( (searched_page_id > first_page_id) ,
@@ -893,6 +1105,7 @@
 thread_t * this  = CURRENT_THREAD;
 if( DEBUG_FATFS_GET_CLUSTER < cycle )
-printk("\n[%s] thread[%x,%x] enter / first_cluster_id %x / searched_page_id %d / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, first_cluster_id, searched_page_id, cycle );
+printk("\n[%s] thread[%x,%x] enter / frst_pid %x / frst_cid %x / srch_pid %d / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid,
+first_page_id, first_cluster_id, searched_page_id, cycle );
 #endif
 
@@ -903,7 +1116,10 @@
     fatfs_ctx_t * loc_fatfs_ctx = vfs_ctx->extend;
 
-    // get extended pointer and cluster on FAT mapper
-    xptr_t fat_mapper_xp  = loc_fatfs_ctx->fat_mapper_xp;
-    cxy_t  fat_cxy        = GET_CXY( fat_mapper_xp );
+    // get FAT cluster
+    fat_cxy = CONFIG_VFS_ROOT_CXY;
+    
+    // get pointers on FAT mapper
+    fat_mapper_ptr = loc_fatfs_ctx->fat_mapper;
+    fat_mapper_xp  = XPTR( fat_cxy , fat_mapper_ptr );
 
     // get local pointer on FATFS context in FAT cluster 
@@ -931,5 +1147,5 @@
 
         // get pointer on current page descriptor in FAT mapper
-        xptr_t current_page_xp = mapper_remote_get_page( fat_mapper_xp , fat_page_index );
+        xptr_t current_page_xp = mapper_get_fat_page( fat_mapper_xp , fat_page_index );
 
         if( current_page_xp == XPTR_NULL )
@@ -942,12 +1158,11 @@
 
         // get pointer on buffer containing the FAT mapper page
-        xptr_t base_xp = ppm_page2base( current_page_xp );
-        uint32_t * buffer = (uint32_t *)GET_PTR( base_xp );
+        xptr_t     base_xp = ppm_page2base( current_page_xp );
+        uint32_t * buffer  = (uint32_t *)GET_PTR( base_xp );
 
         // get next_cluster_id from FAT slot  
         uint32_t next_cluster_id = hal_remote_l32( XPTR( fat_cxy, &buffer[fat_slot_index] ) );
 
-        // allocate a new FAT cluster when there is no cluster
-        // allocated on device for the current page
+        // allocate a new FAT cluster when END_OF_CHAIN found
         if( next_cluster_id >= END_OF_CHAIN_CLUSTER_MIN ) 
         {
@@ -956,6 +1171,6 @@
 
             // allocate a new cluster_id (and update both FAT mapper and FAT on device).
-            error_t error = fatfs_cluster_alloc( &next_cluster_id );
-
+            error = fatfs_cluster_alloc( current_cluster_id,
+                                         &next_cluster_id );
             if( error )
             {
@@ -968,5 +1183,5 @@
 #if (DEBUG_FATFS_GET_CLUSTER & 1)
 if( DEBUG_FATFS_GET_CLUSTER < cycle )
-printk("\n[%s] allocated a new cluster_id %d in FATFS\n",
+printk("\n[%s] allocated a new cluster_id %x in FATFS\n",
 __FUNCTION__, next_cluster_id );
 #endif
@@ -977,6 +1192,6 @@
 #if (DEBUG_FATFS_GET_CLUSTER & 1)
 if( DEBUG_FATFS_GET_CLUSTER < cycle )
-printk("\n[%s] traverse FAT / fat_page_index %d / fat_slot_index %d / next_cluster_id %x\n",
-__FUNCTION__, fat_page_index, fat_slot_index , next_cluster_id );
+printk("\n[%s] traverse FAT / current_cluster_id %x / next_cluster_id %x\n",
+__FUNCTION__, current_cluster_id , next_cluster_id );
 #endif
 
@@ -991,6 +1206,7 @@
 #if DEBUG_FATFS_GET_CLUSTER
 if( DEBUG_FATFS_GET_CLUSTER < cycle )
-printk("\n[%s] thread[%x,%x] exit / searched_cluster_id = %d\n",
-__FUNCTION__, this->process->pid, this->trdid, current_cluster_id );
+printk("\n[%s] thread[%x,%x] exit / frst_pid %d / frst_cid %x / srch_pid %d / srch_cid %x\n",
+__FUNCTION__, this->process->pid, this->trdid,
+first_page_id, first_cluster_id, searched_page_id, current_cluster_id );
 #endif
 
